#include<iostream>
#include<cstring>
using namespace std;
int main(){
int n, mas[100];
bool x=true;
cin>>n;
for(int i=0; i<n; i++)
    mas[i]=i+1;
int maxi=0, us=0, minalo=0;
for(int k=2; maxi!=1; k++)
{
    for(int i=1; i<n; i++)
    {
            if(i%k!=0 && mas[i]!=0)
                mas[i]=0;

    }
        for(int g=0; g<n; g++)
            cout<<mas[g]<<" ";
        cout<<endl;
        minalo=us;
        us=maxi;
        maxi=0;
        for(int j=0; j<n; j++)
        {
            if(mas[j]>maxi)
            {
                maxi=mas[j];
            }
        }
        if(maxi==1)
        {
            x=false;
            break;
        }
}
cout<<minalo<<endl;

return 0;
}
